# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2
from ..core.unchecked_base_model import UncheckedBaseModel
from .temperature_sample import TemperatureSample


class TemperatureData(UncheckedBaseModel):
    ambient_temperature_samples: typing.Optional[typing.List[TemperatureSample]] = pydantic.Field(default=None)
    """
    List of ambient temperature measurements sampled throughout the day.
    """

    body_temperature_samples: typing.Optional[typing.List[TemperatureSample]] = pydantic.Field(default=None)
    """
    List of body temperature measurements sampled throughout the day.
    """

    skin_temperature_samples: typing.Optional[typing.List[TemperatureSample]] = pydantic.Field(default=None)
    """
    List of skin temperature measurements sampled throughout the day.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
